<template>
  <div
    class="flex justify-center"
    @keydown.esc="fullImageSrc = undefined"
    tabindex="0"
  >
    <div
      class="m-5 shadow-2xl"
      v-if="fullImageSrc"
      @click="fullImageSrc = undefined"
      style="position: fixed;"
    >
      <button
        class="absolute text-3xl top-0 right-0 mr-3"
        title="Close the image"
      >×</button>
      <img
        class="rounded-md"
        :src="fullImageSrc"
      />
    </div>
    <div class="m-10 max-w-6xl">
      <div class="rounded max-w-xl mt-20 mb-40">
        <div class="title">
          Create generative art algorithms
        </div>
        <p class="desc">
          Here you will find an example of how you can use adacraft to create
          algorithms that will automatically generate visuals based on some
          randomness combined with your chosen constraints.
        </p>
        <p class="desc">
          The example shown here will create a kind of maze-like generative art.
          It will randomly go through 3×3 patterns containing only squares, and
          stamp it before going to the next column, line by line.
        </p>
        <p class="desc">
          You can view the full code for this example
          <a class="ada-link" href="/studio?project=20945b28" >here</a>.
        </p>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <div>
          <img
            width=250
            @click="showImage"
            src="../assets/how-to/generative-art/gen_delete_sprite.png"
            class="block lg:block rounded-md m-4 max-w-xl"
          />
        </div>
        <div>
          <img
            width=170
            @click="showImage"
            src="../assets/how-to/generative-art/gen_paint_sprite.png"
            class="block lg:block rounded-md m-4 max-w-xl"
          />
        </div>
        <div class="info-zone">
          <div class="header">
            A new sprite for your visuals
          </div>
          <p class="desc">
            You have to first delete the default "star" sprite then add a new
            sprite that you will "paint". At the bottom right you will find the
            "add sprite" tool, and then the "paint" button.
          </p>
        </div>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <div class="info-zone">
          <div class="header">
            Draw all the 3×3 patterns
          </div>
          <p class="desc">
            Now go to the "Costumes" tab of the sprite you have just created,
            select bitmap drawing, choose a color and start drawing a first
            pattern that contains some squares on a 3×3 grid.
          </p>
          <p class="desc">
            Right-click on the icon of the costume you've just created and click
            on "duplicate". Then draw a new pattern from this. Repeat for all
            the patterns you want to create.
          </p>
          <p class="desc">
            In this example we choose to draw patterns with the following
            constraints: the center is always filled and the corners are always
            empty. This leads to 16 patterns.
          </p>
        </div>
        <div>
          <img
            @click="showImage"
            src="../assets/how-to/generative-art/gen_costumes_drawing.png"
            class="block lg:block rounded-md m-4 max-w-xl"
          />
        </div>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <div>
          <img
            @click="showImage"
            src="../assets/how-to/generative-art/gen_extensions_button.png"
            class="block lg:block rounded-md m-4 max-w-xl"
          />
        </div>
        <div>
          <img
            width=300 @click="showImage"
            src="../assets/how-to/generative-art/gen_select_pen_extension.png"
            class="block lg:block rounded-md m-4 max-w-xl"
          />
        </div>
        <div class="info-zone">
          <div class="header">
            Load the pen extension
          </div>
          <p class="desc">
            To generate the image we will stamp the patterns on the background.
            For that, we need the block "stamp" from the pen extension.
          </p>
          <p class="desc">
            Open this extension by first clicking on the extensions button at
            the lower left of the editor.
          </p>
        </div>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <div class="info-zone">
          <div class="header">
            Create the algorithm
          </div>
          <p class="desc">
            Use the blocks to move your sprite along a grid, randomly change its
            costume (i.e. the pattern), use the stamp block from the pen
            extension.
          </p>
          <p class="desc">
            Depending on your pattern drawings, you will have to adjust the
            parameters: number of horizontal and vertical steps, size of the
            step, and the start of the lines and columns.
          </p>
        </div>
        <div>
          <img
            @click="showImage"
            src="../assets/how-to/generative-art/gen_full_project.png"
            class="block lg:block rounded-md m-4 max-w-xl"
          />
        </div>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <img
          width=500
          @click="showImage"
          src="../assets/how-to/generative-art/gen_result.png"
          class="block lg:block rounded-md m-4 max-w-xl"
        />
        <div class="info-zone">
          <div class="header">
            And voilà!
          </div>
          <p class="desc">
            Click on the green flag to execute your generative art and see the
            result in the scene. You can switch to full screen for a better
            rendering effect.
          </p>
        </div>
      </div>

    </div>
  </div>
</template>

<script>

export default {
  name: 'ThePageHowtoVision',
  data () {
    return {
      fullImageSrc: undefined
    }
  },
  methods: {
    showImage (event) {
      if (event.target && event.target.src) {
        this.fullImageSrc = event.target.src
      }
    }
  }
}
</script>

<style lang="postcss" scoped>
.title {
  @apply md:mt-0 mb-20;
  @apply font-semibold;
  @apply text-6xl text-gray-800;
  @apply dark:text-gray-300;
}

.desc {
  @apply block;
  @apply p-2 pl-0 pt-1;
  @apply text-xl text-gray-600;
  @apply dark:text-gray-400;
}

.info-zone {
  @apply px-4 max-w-xs;
  @apply bg-white;
  @apply dark:bg-gray-800;
}

.header {
  @apply md:mt-0 mb-2;
  @apply font-semibold;
  @apply text-2xl text-gray-800;
  @apply dark:text-gray-300;
}
</style>